program LiveObjectsTracer1V1;

{$APPTYPE CONSOLE}

uses Windows,Classes,SysUtils,IniFiles;

function CreateToolhelp32Snapshot(flag,pid:Integer):integer;
stdcall; external 'kernel32.dll';
function Process32First(handle:Integer;pnt:pointer):Boolean;
stdcall; external 'kernel32.dll';
function Process32Next(handle:Integer;pnt:pointer):Boolean;
stdcall; external 'kernel32.dll';
function ProcessFind(var PidOrName:string):Cardinal;
var s:Cardinal;
p:string;
prc32:record
 dwSize: integer;
 cntUsage: integer;
 th32ProcessID: cardinal;
 th32DefaultHeapID: integer;
 th32ModuleID: integer;
 cntThreads: integer;
 th32ParentProcessID: cardinal;
 pcPriClassBase: integer;
 dwFlags: integer;
 szExeFile: array [0..259] of char;
end;
var cpid,prid:Cardinal;
npid,nexe:string;
last:boolean;
begin
last:=(PidOrName='');
Result:=0;
prid:=0;
cpid:=GetCurrentProcessId();
PidOrName:=Trim(PidOrName);
p:=LowerCase(PidOrName);
s:=CreateToolhelp32Snapshot(2,0);
prc32.dwSize:=system.sizeof(prc32);
if not Process32First(s,@prc32) then exit;
while (Process32Next(s,@prc32)) do begin
if prc32.th32ProcessID=cpid then continue;
nexe:=prc32.szExeFile;
prid:=prc32.th32ProcessID;
npid:=inttostr(prid);
if(npid=PidOrName)or(nexe=PidOrName)or((LowerCase(nexe)=p)and(Result=0)) then begin
Result:=prid;
PidOrName:=nexe;
if(nexe=PidOrName)or(npid=PidOrName) then break;
end;
end;
if last and (Result=0) then begin
Result:=prid;
PidOrName:=nexe;
end;
CloseHandle(s);
end;

const P800=2147483648;

type obj88=record
 Pmemory:Cardinal;
 Pfriend:Cardinal;
 Pcollision:Cardinal;
 X,Y,Z:Integer;
 User1:array[0..1]of Byte;
 Dead:Byte;
 User2:array[3..27]of Byte;
 Rtype:Word;
 Otype:Word;
 Middle:array[0..3]of Byte;
 Atype:Byte;
 Frame:Byte;
 Animation:array[0..3]of Byte;
 Critical:array[0..1]of Byte;
 U,V,W,D:Byte;
 State:Byte;
 Additional:array[1..6]of Byte;
 S:Byte;
 Last:array[0..7]of Byte;
end;

type objsize_=record
siz,int,act,max:integer;end;

var
pid,han,ramtop,objptr,objstart:Integer;
objsize,objlast:objsize_;
objdata:array [0..1023] of obj88;
objzero:obj88;
lost:Boolean;

function mb2(val:integer):integer;
begin
Result:=(val and $1fffff);
end;


procedure readgamememory(from:Cardinal;dest:Pointer;size:Cardinal);
var n:Cardinal;
begin
from:=mb2(from)+ramtop;
if (not ReadProcessMemory(han,Ptr(from),dest,size,n))or(n<>size) then Abort;
end;

procedure refreshobjects();
begin
try
readgamememory(objptr,@objstart,4);
objstart:=mb2(objstart);
readgamememory(objstart-8,@objsize,8);
objsize.siz:=mb2(objsize.siz-8);
if (objsize.siz>1023*88)or(objsize.int>1023) then Abort;
readgamememory(objstart,@objdata[0],objsize.siz);
objsize.siz:=objsize.siz div 88;
if lost then begin
if not CompareMem(@objlast,@objsize,sizeof(objsize)) then Write(chr(10),chr(13));
end;
lost:=false;
except
if lost then exit;
lost:=true;
end;
end;

procedure countobjects();
var i:integer;
begin
if lost then exit;
objsize.act:=0;
objsize.max:=0;
for i:=0 to objsize.siz-1 do begin
if (objdata[i].Pmemory<>0)and(objdata[i].Dead=0)and((objdata[i].State and 128)=0) then Inc(objsize.act);
if not CompareMem(@objdata[i],@objzero,88) then Inc(objsize.max);
end;

end;

const anim:string='-\|/';
var s,proc:string;
i:integer;
ini:TIniFile;

begin
if ParamCount=0 then ini:=TIniFile.Create(ParamStr(0)+'.ini')
else ini:=TIniFile.Create(ParamStr(1));
proc:=ini.ReadString('main','process','ePSXe.exe');
ramtop:=StrToIntDef(ini.ReadString('main','ramtop','0'),0);
objptr:=StrToIntDef(ini.ReadString('main','objptr','0'),0);
ini.Free;
if(ramtop<1)or(objptr<1)then begin
Writeln('wrong ini file!');
Readln(s);
exit;
end;
s:=proc;
pid:=ProcessFind(s);
han:=0;
if pid<>0 then han:=OpenProcess(PROCESS_VM_READ,false,pid);
if(han=-1)or(han=0) then begin
Writeln('Process not found - "',proc,'"');
Readln(s);
exit;
end;
objsize.max:=0;
ZeroMemory(@objzero,88);
i:=0;
while true do begin
refreshobjects();
countobjects();
if lost then Write(chr(13),anim[i+1])
else begin
if (objsize.max<>0)and((objlast.int<>objsize.int)or(objlast.siz<>objsize.siz))then Write('?',chr(10),chr(13));
if objlast.max>objsize.max then begin
Write('!',chr(10),chr(13));
end;
objlast:=objsize;
Write(chr(13),anim[i+1],#9,'I:',objsize.int,#9,'S:',objsize.siz,#9,'A:',objsize.act,#9,'M:',objsize.max,#9#9);
end;
i:=(i+1)mod Length(anim);
if lost then begin
if(han<>0)and(han<>-1)then CloseHandle(han);
Sleep(500);
s:=proc;
han:=OpenProcess(PROCESS_VM_READ,false,ProcessFind(proc));
end else Sleep(50);
end;

end.
